// Auto-generated. Do not edit!

// (in-package kvh_geo_fog_3d_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class KvhGeoFog3DSatellites {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.hdop = null;
      this.vdop = null;
      this.gps_satellites = null;
      this.glonass_satellites = null;
      this.beidou_satellites = null;
      this.galileo_satellites = null;
      this.sbas_satellites = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('hdop')) {
        this.hdop = initObj.hdop
      }
      else {
        this.hdop = 0.0;
      }
      if (initObj.hasOwnProperty('vdop')) {
        this.vdop = initObj.vdop
      }
      else {
        this.vdop = 0.0;
      }
      if (initObj.hasOwnProperty('gps_satellites')) {
        this.gps_satellites = initObj.gps_satellites
      }
      else {
        this.gps_satellites = 0;
      }
      if (initObj.hasOwnProperty('glonass_satellites')) {
        this.glonass_satellites = initObj.glonass_satellites
      }
      else {
        this.glonass_satellites = 0;
      }
      if (initObj.hasOwnProperty('beidou_satellites')) {
        this.beidou_satellites = initObj.beidou_satellites
      }
      else {
        this.beidou_satellites = 0;
      }
      if (initObj.hasOwnProperty('galileo_satellites')) {
        this.galileo_satellites = initObj.galileo_satellites
      }
      else {
        this.galileo_satellites = 0;
      }
      if (initObj.hasOwnProperty('sbas_satellites')) {
        this.sbas_satellites = initObj.sbas_satellites
      }
      else {
        this.sbas_satellites = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type KvhGeoFog3DSatellites
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [hdop]
    bufferOffset = _serializer.float32(obj.hdop, buffer, bufferOffset);
    // Serialize message field [vdop]
    bufferOffset = _serializer.float32(obj.vdop, buffer, bufferOffset);
    // Serialize message field [gps_satellites]
    bufferOffset = _serializer.uint8(obj.gps_satellites, buffer, bufferOffset);
    // Serialize message field [glonass_satellites]
    bufferOffset = _serializer.uint8(obj.glonass_satellites, buffer, bufferOffset);
    // Serialize message field [beidou_satellites]
    bufferOffset = _serializer.uint8(obj.beidou_satellites, buffer, bufferOffset);
    // Serialize message field [galileo_satellites]
    bufferOffset = _serializer.uint8(obj.galileo_satellites, buffer, bufferOffset);
    // Serialize message field [sbas_satellites]
    bufferOffset = _serializer.uint8(obj.sbas_satellites, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type KvhGeoFog3DSatellites
    let len;
    let data = new KvhGeoFog3DSatellites(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [hdop]
    data.hdop = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [vdop]
    data.vdop = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [gps_satellites]
    data.gps_satellites = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [glonass_satellites]
    data.glonass_satellites = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [beidou_satellites]
    data.beidou_satellites = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [galileo_satellites]
    data.galileo_satellites = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [sbas_satellites]
    data.sbas_satellites = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    return length + 13;
  }

  static datatype() {
    // Returns string type for a message object
    return 'kvh_geo_fog_3d_msgs/KvhGeoFog3DSatellites';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e7f6cf68f4324d6c18687862aad81655';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    ###############################################
    # Satellites message for the KVH GEO FOG 3D satellites packet
    ###############################################
    
    #
    # ROS message header.
    # header.stamp specifies the ROS time for this measurement. Satellite
    # time is reported as unix_time_s and unix_time_us.
    #
    Header header
    
    #
    # Horizontal dilution of precision (HDOP). Describes
    # the strength of current satellite configuration.
    #
    float32 hdop
    
    #
    # Vertical dilution of precision (VDOP). Describes
    # the strength of current satellite configuration.
    #
    float32 vdop
    
    #
    # Number of total satellites in sight
    #
    uint8 gps_satellites
    
    #
    # Number of glonass satellites in sight
    #
    uint8 glonass_satellites
    
    #
    # Number of beidou satellites in sight
    #
    uint8 beidou_satellites
    
    #
    # Number of galileo satellites in sight
    #
    uint8 galileo_satellites
    
    #
    # Number of sbas satellites in sight
    #
    uint8 sbas_satellites
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new KvhGeoFog3DSatellites(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.hdop !== undefined) {
      resolved.hdop = msg.hdop;
    }
    else {
      resolved.hdop = 0.0
    }

    if (msg.vdop !== undefined) {
      resolved.vdop = msg.vdop;
    }
    else {
      resolved.vdop = 0.0
    }

    if (msg.gps_satellites !== undefined) {
      resolved.gps_satellites = msg.gps_satellites;
    }
    else {
      resolved.gps_satellites = 0
    }

    if (msg.glonass_satellites !== undefined) {
      resolved.glonass_satellites = msg.glonass_satellites;
    }
    else {
      resolved.glonass_satellites = 0
    }

    if (msg.beidou_satellites !== undefined) {
      resolved.beidou_satellites = msg.beidou_satellites;
    }
    else {
      resolved.beidou_satellites = 0
    }

    if (msg.galileo_satellites !== undefined) {
      resolved.galileo_satellites = msg.galileo_satellites;
    }
    else {
      resolved.galileo_satellites = 0
    }

    if (msg.sbas_satellites !== undefined) {
      resolved.sbas_satellites = msg.sbas_satellites;
    }
    else {
      resolved.sbas_satellites = 0
    }

    return resolved;
    }
};

module.exports = KvhGeoFog3DSatellites;
