// Auto-generated. Do not edit!

// (in-package kvh_geo_fog_3d_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class KvhGeoFog3DUTMPosition {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.northing_m = null;
      this.easting_m = null;
      this.height_m = null;
      this.zone_character = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('northing_m')) {
        this.northing_m = initObj.northing_m
      }
      else {
        this.northing_m = 0.0;
      }
      if (initObj.hasOwnProperty('easting_m')) {
        this.easting_m = initObj.easting_m
      }
      else {
        this.easting_m = 0.0;
      }
      if (initObj.hasOwnProperty('height_m')) {
        this.height_m = initObj.height_m
      }
      else {
        this.height_m = 0.0;
      }
      if (initObj.hasOwnProperty('zone_character')) {
        this.zone_character = initObj.zone_character
      }
      else {
        this.zone_character = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type KvhGeoFog3DUTMPosition
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [northing_m]
    bufferOffset = _serializer.float64(obj.northing_m, buffer, bufferOffset);
    // Serialize message field [easting_m]
    bufferOffset = _serializer.float64(obj.easting_m, buffer, bufferOffset);
    // Serialize message field [height_m]
    bufferOffset = _serializer.float64(obj.height_m, buffer, bufferOffset);
    // Serialize message field [zone_character]
    bufferOffset = _serializer.char(obj.zone_character, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type KvhGeoFog3DUTMPosition
    let len;
    let data = new KvhGeoFog3DUTMPosition(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [northing_m]
    data.northing_m = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [easting_m]
    data.easting_m = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [height_m]
    data.height_m = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [zone_character]
    data.zone_character = _deserializer.char(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    return length + 25;
  }

  static datatype() {
    // Returns string type for a message object
    return 'kvh_geo_fog_3d_msgs/KvhGeoFog3DUTMPosition';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '68e1501b18625e1e1ec67eeaa30f253a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    ####################################
    # UTM Position message for KVH GEO FOG 3D UTM position packet
    ####################################
    
    #
    # ROS message header.
    # header.stamp specifies the ROS time for this measurement. Satellite
    # time is reported as unix_time_s and unix_time_us.
    #
    Header header
    
    #
    # Northing in meters
    #
    float64 northing_m
    
    #
    # Easting in meters
    #
    float64 easting_m
    
    #
    # Height in meters
    #
    float64 height_m
    
    #
    # Zone number
    # (Does not seem to exist in the spatial_packets.h header file, only in the documentation)
    # uint8 zone_number
    
    #
    # Zone character
    #
    char zone_character
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new KvhGeoFog3DUTMPosition(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.northing_m !== undefined) {
      resolved.northing_m = msg.northing_m;
    }
    else {
      resolved.northing_m = 0.0
    }

    if (msg.easting_m !== undefined) {
      resolved.easting_m = msg.easting_m;
    }
    else {
      resolved.easting_m = 0.0
    }

    if (msg.height_m !== undefined) {
      resolved.height_m = msg.height_m;
    }
    else {
      resolved.height_m = 0.0
    }

    if (msg.zone_character !== undefined) {
      resolved.zone_character = msg.zone_character;
    }
    else {
      resolved.zone_character = 0
    }

    return resolved;
    }
};

module.exports = KvhGeoFog3DUTMPosition;
